<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div>

  <div class="modal-header">
    <h4
      class="modal-title"
      id="modal-basic-title"
      [innerText]="(!layer.id) ? messages.LAYER_CREATION : messages.LAYER_EDITION"></h4>
    <button
      type="button"
      class="btn-close"
      [title]="commonMessages.CLOSE"
      (click)="activeModal.dismiss(commonMessages.ACTION_RESULT_CANCEL)">
    </button>
  </div>

  <div class="modal-body">

    <ul
      ngbNav
      #nav="ngbNav"
      class="ip-tabs"
      (navChange)="onNavElementClicked($event)">

      <li
        [ngbNavItem]="tabEnum.General"
        [destroyOnHide]="false">
        <a ngbNavLink>
          <span [innerText]="messages.TAB_GENERAL"></span>
          <fa-icon
            *ngIf="!isGeneralTabValid"
            [icon]="commonIcons.INVALID_FORM_ICON"
            class="ip-tab-error-icon">
          </fa-icon>
        </a>
        <ng-template ngbNavContent>
          <app-edit-layer-general
            [editMode]="!!layer.id"
            [layer]="layer"
            [userPreferences]="userPreferences"
            (validityStateChanged)="onGeneralValidityChanged($event)">
          </app-edit-layer-general>
        </ng-template>
      </li>

      <li
        [ngbNavItem]="tabEnum.Stamps"
        [disabled]="!layer.id"
        [destroyOnHide]="false">
        <a ngbNavLink [innerText]="messages.TAB_STAMPS"></a>
        <ng-template ngbNavContent>
          <div *ngIf="!!layer.id">
            <app-edit-layer-stamp-list
              [tenantId]="tenantId"
              (pendingImageIdAdded)="onPendingImageIdAdded($event)"
              [layer]="layer">
            </app-edit-layer-stamp-list>
          </div>
        </ng-template>
      </li>

      <li
        [ngbNavItem]="tabEnum.Example"
        [disabled]="!layer.id"
        [destroyOnHide]="false">
        <a ngbNavLink [innerText]="commonMessages.TAB_EXAMPLE"></a>
        <ng-template ngbNavContent>
          <div *ngIf="!!layer.id">
            <app-pdf-example
              [pdfSource]="layerSrc"
              [lastModificationDate]="lastModificationDate">
            </app-pdf-example>
          </div>
        </ng-template>
      </li>

    </ul>

    <div
      class="p-4"
      [ngbNavOutlet]="nav">
    </div>

  </div>

  <div class="modal-footer">
    <button
      ls-button-cancel
      (click)="onCancelButtonClicked()">
    </button>
    <button
      ls-button-save [processing]="isProcessing"
      (click)="submit()"
      [disabled]="!isFormValid">
    </button>
  </div>

</div>
